<template>
  <b-modal
    title="Approve Invoice"
    small
    :visible.sync="visible"
    @close="handleClose"
  >
    <CamundaForm v-model="formData"></CamundaForm>

    <!-- Footer -->
    <div slot="footer" class="d-flex content-end">
      <b-button @click.prevent="handleClose">Cancel</b-button>
      <b-button
        native-type="submit"
        primary
        class="ml-4x"
        @click.prevent="handleSubmit"
        >Submit</b-button
      >
    </div>
  </b-modal>
</template>

<script lang="ts">
import Vue from 'vue'
import CamundaForm from '~/partials/camunda/CamundaForm.vue'

export default Vue.extend({
  name: 'ApproveInvoiceModal2',
  components: {
    CamundaForm,
  },
  props: {
    entity: {
      type: Object,
      default() {
        return {}
      },
    },
  },
  data() {
    return {
      visible: false,
      invoice: {
        name: '',
        orderId: '',
      },
      task: null as any,
      formData: [] as any[],
    }
  },
  async created() {
    await this.loadForm()
    setTimeout(() => (this.visible = true), 1)
  },
  methods: {
    async loadForm() {
      const task = await this.$services.law.getTaskByProcessInstanceIdAndName(
        this.entity.processInstanceId,
        'Approve Invoice'
      )
      console.log('task', task)
      this.task = task

      if (!this.task) {
        this.$emit('close')
        return
      }

      this.formData = await this.$services.law.getTaskVariables(this.task.id)
    },
    async handleSubmit() {
      const data = this.formData.reduce((a, b) => {
        a[b.key] = {
          type: b.type,
          value: b.value,
        }
        return a
      }, {})
      const rs = await this.$services.law.submitTask(this.task.id, {
        variables: data,
      })
      console.log('submitTask', rs)

      this.$emit('submit')
    },
    handleClose() {
      this.$emit('close')
    },
  },
})
</script>
